      SUBROUTINE PLDATA_CLEAR

!      INCLUDE 'plcomd.inc'
      USE PLCOM3, ONLY : NRM, NWRM, NWMM
      USE PLDAT0
      USE PLDAT2
      USE PLDAT3
      USE PLDAT4
      USE PLDAT5

      IMPLICIT NONE

      INTEGER(4)  :: NS, NR, NWR, NWM

      DO NS=1,NSMAXPL
         DO NR=1,NRMAXPL
            RNPL(NR,NS)=0.D0
            RTPL(NR,NS)=3.D-5
            RUPL(NR,NS)=0.D0
         ENDDO
      ENDDO
      DO NWR=1,NWRM
         KIDWR(NWR)=' '
         DO NS=1,NSMAXPL
            DO NR=1,NRMAXPL
               PWRPL(NR,NS,NWR) =0.D0
            ENDDO
         ENDDO
         DO NR=1,NRMAXPL
            AJWRPL(NR,NWR)=0.D0
         ENDDO
      ENDDO
      DO NWM=1,NWMM
         KIDWM(NWM)=' '
         DO NS=1,NSMAXPL
            DO NR=1,NRMAXPL
               PWMPL(NR,NS,NWM) =0.D0
            ENDDO
         ENDDO
         DO NR=1,NRMAXPL
            AJWMPL(NR,NWM)=0.D0
         ENDDO
      ENDDO
      NWRMAX=0
      NWMMAX=0
      NSPL=0
      RETURN
      END

      SUBROUTINE PLDATA_SETN(NRMAXPL1,NSMAXPL1)

!      INCLUDE 'plcomd.inc'
      USE PLDAT0, ONLY : NRMAXPL, NSMAXPL
      IMPLICIT NONE
      INTEGER(4), INTENT(IN)  :: NRMAXPL1, NSMAXPL1

      NRMAXPL=NRMAXPL1
      NSMAXPL=NSMAXPL1
      RETURN
      END

      SUBROUTINE PLDATA_GETN(NRMAXPL1,NSMAXPL1)

!      INCLUDE 'plcomd.inc'
      USE PLDAT0, ONLY : NRMAXPL, NSMAXPL
      IMPLICIT NONE
      INTEGER(4), INTENT(OUT) :: NRMAXPL1, NSMAXPL1

      NRMAXPL1=NRMAXPL
      NSMAXPL1=NSMAXPL
      RETURN
      END

      SUBROUTINE PLDATA_GETNW(NWRMAX1,NWMMAX1)

!      INCLUDE 'plcomd.inc'
      USE PLDAT0, ONLY : NWRMAX, NWMMAX
      IMPLICIT NONE
      INTEGER(4), INTENT(OUT)  :: NWRMAX1, NWMMAX1

      NWRMAX1=NWRMAX
      NWMMAX1=NWMMAX
      RETURN
      END

      SUBROUTINE PLDATA_SETR(RGPL1,RMPL1)

!      INCLUDE 'plcomd.inc'
      USE PLCOM3, ONLY : NRM
      USE PLDAT0, ONLY : NRMAXPL
      USE PLDAT1
      IMPLICIT NONE
      REAL(8), DIMENSION(NRM), INTENT(IN) :: RGPL1, RMPL1
      INTEGER(4)  :: NR

      DO NR=1,NRMAXPL
         RGPL(NR)=RGPL1(NR)
         RMPL(NR)=RMPL1(NR)
      ENDDO
      RETURN
      END

      SUBROUTINE PLDATA_GETR(RGPL1,RMPL1)

!      INCLUDE 'plcomd.inc'
      USE PLCOM3, ONLY : NRM
      USE PLDAT0, ONLY : NRMAXPL
      USE PLDAT1
      IMPLICIT NONE
      REAL(8), DIMENSION(NRM), INTENT(OUT) :: RGPL1, RMPL1
      INTEGER(4)  :: NR

      DO NR=1,NRMAXPL
         RGPL1(NR)=RGPL(NR)
         RMPL1(NR)=RMPL(NR)
      ENDDO
      RETURN
      END

      SUBROUTINE PLDATA_SETP(NRM1,RNPL1,RTPL1,RUPL1)

!      INCLUDE 'plcomd.inc'
      USE PLCOM0
      USE PLDAT0, ONLY : NRMAXPL, NSMAXPL, NSPL
      USE PLDAT2

      IMPLICIT NONE

      INTEGER(4), INTENT(IN) :: NRM1
      REAL(8), DIMENSION(NRM1,NSM), INTENT(IN) :: RNPL1, RTPL1, RUPL1
      INTEGER(4)  :: NS, NR

!      WRITE(6,*) NRM,NRM1

      DO NS=1,NSMAXPL
      DO NR=1,NRMAXPL
         RNPL(NR,NS)=RNPL1(NR,NS)
         RTPL(NR,NS)=RTPL1(NR,NS)
         RUPL(NR,NS)=RUPL1(NR,NS)
      ENDDO
      ENDDO
!      WRITE(6,'(1P4E12.4)') RNPL(1,1),RTPL(1,1),RNPL(1,2),RTPL(1,2)
      NSPL=0
      RETURN
      END

      SUBROUTINE PLDATA_GETP(RNPL1,RTPL1,RUPL1)

!      INCLUDE 'plcomd.inc'
      USE PLCOM0
      USE PLDAT0, ONLY : NRMAXPL, NSMAXPL
      USE PLDAT2

      IMPLICIT NONE

      REAL(8), DIMENSION(NRM,NSM), INTENT(OUT) :: RNPL1, RTPL1, RUPL1
      INTEGER(4)  :: NS, NR

      DO NS=1,NSMAXPL
      DO NR=1,NRMAXPL
         RNPL1(NR,NS)=RNPL(NR,NS)
         RTPL1(NR,NS)=RTPL(NR,NS)
         RUPL1(NR,NS)=RUPL(NR,NS)
      ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE PLDATA_GETPL(RHOL,RNPL1,RTPL1,RUPL1)

!      INCLUDE 'plcomd.inc'
      USE PLCOM0
      USE PLDAT0, ONLY : NRMAXPL, NSMAXPL, NSPL
      USE PLDAT6
      USE PLDAT7

      IMPLICIT NONE
      REAL(8), DIMENSION(NSM), INTENT(OUT) :: RNPL1, RTPL1, RUPL1
      REAL(8), INTENT(IN)               :: RHOL
      INTEGER(4)  :: NS, IERR
      REAL(8)     :: RHOLL

      IF(NSPL.EQ.0) CALL PLDATA_SPL

      RHOLL=RHOL
      IF(RHOLL.GE.1.D0) RHOLL=1.D0

      DO NS=1,NSMAXPL
         CALL SPL1DF(RHOLL,RNPL1(NS),URPL,URNPL(1,1,NS), NRMAXPL+2,IERR)
         IF(IERR.NE.0) WRITE(6,*) 'XX PLDATA_GETPL/RN: SPL1DF ERROR: IERR=',IERR
         CALL SPL1DF(RHOLL,RTPL1(NS),URPL,URTPL(1,1,NS), NRMAXPL+2,IERR)
         IF(IERR.NE.0) WRITE(6,*) 'XX PLDATA_GETPL/RT: SPL1DF ERROR: IERR=',IERR
         CALL SPL1DF(RHOLL,RUPL1(NS),URPL,URUPL(1,1,NS), NRMAXPL+2,IERR)
         IF(IERR.NE.0) WRITE(6,*) 'XX PLDATA_GETP/RUL: SPL1DF ERROR: IERR=',IERR
      ENDDO
      RETURN
      END

      SUBROUTINE PLDATA_SPL

!      INCLUDE 'plcomd.inc'
      USE PLCOM3, ONLY : NRMPP
      USE PLDAT0, ONLY : NRMAXPL, NSMAXPL, NSPL
      USE PLDAT1, ONLY : RMPL
      USE PLDAT2
      USE PLDAT6
      USE PLDAT7

      IMPLICIT NONE
      REAL(8), DIMENSION(NRMPP) :: F, DF
      INTEGER(4)  :: NS, NR, IERR

      DO NR=1,NRMAXPL
         URPL(NR+1)=RMPL(NR)
      ENDDO
      URPL(1)=0.D0
      URPL(NRMAXPL+2)=1.D0

      DO NS=1,NSMAXPL
         DO NR=1,NRMAXPL
            F(NR+1)=RNPL(NR,NS)
         ENDDO
         F(1)=(9.D0*F(2)-F(3))/8.D0
         F(NRMAXPL+2)=(3.D0*F(NRMAXPL+1)-F(NRMAXPL))/2.D0
         DF(1)=0.D0
         CALL SPL1D(URPL,F,DF,URNPL(1,1,NS),NRMAXPL+2,1,IERR)
         IF(IERR.NE.0) WRITE(6,*) 'XX PLDATA_SPL/RN: SPL1D ERROR: IERR=',IERR

         DO NR=1,NRMAXPL
            F(NR+1)=RTPL(NR,NS)
         ENDDO
         F(1)=(9.D0*F(2)-F(3))/8.D0
         F(NRMAXPL+2)=(3.D0*F(NRMAXPL+1)-F(NRMAXPL))/2.D0
         DF(1)=0.D0
         CALL SPL1D(URPL,F,DF,URTPL(1,1,NS),NRMAXPL+2,1,IERR)
         IF(IERR.NE.0) WRITE(6,*) 'XX PLDATA_SPL/RT: SPL1D ERROR: IERR=',IERR

         DO NR=1,NRMAXPL
            F(NR+1)=RUPL(NR,NS)
         ENDDO
         F(1)=(9.D0*F(2)-F(3))/8.D0
         F(NRMAXPL+2)=(3.D0*F(NRMAXPL+1)-F(NRMAXPL))/2.D0
         DF(1)=0.D0
         CALL SPL1D(URPL,F,DF,URUPL(1,1,NS),NRMAXPL+2,1,IERR)
         IF(IERR.NE.0) WRITE(6,*) 'XX PLDATA_SPL/RU: SPL1D ERROR: IERR=',IERR

      ENDDO
      NSPL=1
      RETURN
      END

      SUBROUTINE PLDATA_SETWR(NWR,KID,PWRPL1,AJWRPL1)

!      INCLUDE 'plcomd.inc'
      USE PLCOM0
      USE PLCOM3, ONLY : NRM, NWRM
      USE PLDAT0, ONLY : NWRMAX, NRMAXPL, NSMAXPL,   NSPL
      USE PLDAT3
      USE PLDAT5, ONLY : KIDWR

      IMPLICIT NONE

      INTEGER(4),                  INTENT(IN) :: NWR
      REAL(8), DIMENSION(NRM,NSM), INTENT(IN) :: PWRPL1
      REAL(8), DIMENSION(NRM),     INTENT(IN) :: AJWRPL1
      CHARACTER(LEN=80),           INTENT(IN) ::  KID
      INTEGER(4)  ::  NR, NS

      IF(NWR.GT.NWRM) THEN
         WRITE(6,*) 'XX PLDATA_SETWR: NWR.GT.NWRM'
         STOP
      ENDIF
      IF(NWR.GT.NWRMAX) NWRMAX=NWR
      KIDWR(NWR)=KID

      DO NS=1,NSMAXPL
      DO NR=1,NRMAXPL
         PWRPL(NR,NS,NWR)=PWRPL1(NR,NS)
      ENDDO
      ENDDO
      DO NR=1,NRMAXPL
         AJWRPL(NR,NWR)=AJWRPL1(NR)
      ENDDO
      RETURN
      END

      SUBROUTINE PLDATA_GETWR(NWR,KID,PWRPL1,AJWRPL1)

!      INCLUDE 'plcomd.inc'
      USE PLCOM0
      USE PLCOM3, ONLY : NRM, NWRM
      USE PLDAT0, ONLY : NRMAXPL, NSMAXPL
      USE PLDAT3
      USE PLDAT5, ONLY : KIDWR

      IMPLICIT NONE

      INTEGER(4),                  INTENT(IN)  :: NWR
      REAL(8), DIMENSION(NRM,NSM), INTENT(OUT) :: PWRPL1
      REAL(8), DIMENSION(NRM),     INTENT(OUT) :: AJWRPL1
      CHARACTER(LEN=80),           INTENT(OUT) :: KID
      INTEGER(4)  ::  NR, NS

      IF(NWR.GT.NWRM) THEN
         WRITE(6,*) 'XX PLDATA_GETWR: NWR.GT.NWRM'
         RETURN
      ENDIF

      KID=KIDWR(NWR)

      DO NS=1,NSMAXPL
      DO NR=1,NRMAXPL
         PWRPL1(NR,NS)=PWRPL(NR,NS,NWR)
      ENDDO
      ENDDO
      DO NR=1,NRMAXPL
         AJWRPL1(NR)=AJWRPL(NR,NWR)
      ENDDO
      RETURN
      END

      SUBROUTINE PLDATA_SETWM(NWM,KID,PWMPL1,AJWMPL1)

!      INCLUDE 'plcomd.inc'
      USE PLCOM0
      USE PLCOM3, ONLY : NRM, NWMM
      USE PLDAT0, ONLY : NWMMAX, NSMAXPL, NRMAXPL
      USE PLDAT4
      USE PLDAT5, ONLY : KIDWM

      IMPLICIT NONE

      INTEGER(4),                  INTENT(IN) :: NWM
      REAL(8), DIMENSION(NRM,NSM), INTENT(IN) :: PWMPL1
      REAL(8), DIMENSION(NRM),     INTENT(IN) :: AJWMPL1
      CHARACTER(LEN=80),           INTENT(IN) :: KID
      INTEGER(4)  ::  NR, NS

      IF(NWM.GT.NWMM) THEN
         WRITE(6,*) 'XX PLDATA_SETWM: NWM.GT.NWMM'
         STOP
      ENDIF
      IF(NWM.GT.NWMMAX) NWMMAX=NWM

      KIDWM(NWM)=KID

      DO NS=1,NSMAXPL
      DO NR=1,NRMAXPL
         PWMPL(NR,NS,NWM)=PWMPL1(NR,NS)
      ENDDO
      ENDDO
      DO NR=1,NRMAXPL
         AJWMPL(NR,NWM)=AJWMPL1(NR)
      ENDDO
      RETURN
      END

      SUBROUTINE PLDATA_GETWM(NWM,KID,PWMPL1,AJWMPL1)

!      INCLUDE 'plcomd.inc'
      USE PLCOM0
      USE PLCOM3, ONLY : NRM, NWMM
      USE PLDAT0, ONLY : NWMMAX, NSMAXPL, NRMAXPL
      USE PLDAT4
      USE PLDAT5, ONLY : KIDWM

      IMPLICIT NONE

      INTEGER(4),                  INTENT(IN)  :: NWM
      REAL(8), DIMENSION(NRM,NSM), INTENT(OUT) :: PWMPL1
      REAL(8), DIMENSION(NRM),     INTENT(OUT) :: AJWMPL1
      CHARACTER(LEN=80),           INTENT(OUT) :: KID
      INTEGER(4)  ::  NR, NS

      IF(NWM.GT.NWMM) THEN
         WRITE(6,*) 'XX PLDATA_GETWW: NWM.GT.NWMM'
         RETURN
      ENDIF

      KID=KIDWM(NWM)

      DO NS=1,NSMAXPL
      DO NR=1,NRMAXPL
         PWMPL1(NR,NS)=PWMPL(NR,NS,NWM)
      ENDDO
      ENDDO
      DO NR=1,NRMAXPL
         AJWMPL1(NR)=AJWMPL(NR,NWM)
      ENDDO
      RETURN
      END
