MODULE trgout

! This module produce graphic output

PUBLIC tr_gout
PRIVATE

CONTAINS

  SUBROUTINE tr_gout

    USE trcomm, ONLY: rkind,ikind,nrmax,nsamax,rg,rt,dfa,pha,vca, &
         nitmax,error_it,lmaxtr,epsltr,lt_save,neqrmax,neqmax,neq_neqr,nsa_neq
    USE libgrf
    IMPLICIT NONE
    CHARACTER(LEN=20):: label
    INTEGER(ikind):: neqr,neq,nsa,nit,nitmaxl
    REAL(rkind),DIMENSION(nrmax+1,nsamax):: rtg,dfg,phg,vcg
    REAL(rkind),DIMENSION(nitmax):: ig,erg

    DO neqr=1,neqrmax
       neq=neq_neqr(neqr)
       nsa=nsa_neq(neq)
       rtg(1:nrmax+1,neqr)=rt(nsa,0:nrmax)
       dfg(1:nrmax+1,neqr)=dfa(neq,neq,0:nrmax)
       phg(1:nrmax+1,neqr)=pha(neq,0:nrmax)
       vcg(1:nrmax+1,neqr)=vca(neq,neq,0:nrmax)
    END DO

    ! --- #1 ---
    CALL PAGES
    LABEL = '/T vs r/'
    CALL GRD1D(1,RG,rtg, NRMAX+1, NRMAX+1, neqrmax, LABEL, 0)
    LABEL = '/Diffusion vs r/'
    CALL GRD1D(2,RG,dfg, NRMAX+1, NRMAX+1, neqrmax, LABEL, 0)
    LABEL = '/Heat_pw vs r/'
    CALL GRD1D(3,RG,phg, NRMAX+1, NRMAX+1, neqrmax, LABEL, 0)
    LABEL = '/Convection vs r/'
    CALL GRD1D(4,RG,vcg, NRMAX+1, NRMAX+1, neqrmax, LABEL, 0)
    CALL PAGEE

    
    ! --- #2 ---
    nitmaxl=MIN(nitmax,lmaxtr)
    DO nit=1,nitmaxl
       ig(nit)=dble(nit)
    END DO
    IF(nitmax > 1) THEN
       DO nit=1,nitmaxl
          ig(nit)=dble(nit)
          erg(nit)=log10(error_it(nit)+epsltr*1.D-2)
       END DO

       ! --- #2 ---
       CALL PAGES
       ! MODE = 2 ; X:LINEAR  Y:LOG
       LABEL = '/convergence vs NIT/'
       CALL GRD1D(1,ig,erg, NITMAXL, NITMAXL, 1, LABEL, 2)

       LABEL = '/LT vs r/'
       CALL GRD1D(2,rg,lt_save,nrmax+1,nrmax+1,1,LABEL,1)
       
       CALL PAGEE

    END IF



  END SUBROUTINE tr_gout
END MODULE trgout
