MODULE trloop

! This module advances time upto ntmax*dt

  PUBLIC tr_loop,tr_save_pvprev
  PRIVATE

CONTAINS

  SUBROUTINE tr_loop

    USE trcomm, ONLY: ikind,rkind,ntmax,t,dt
    USE trstep
    IMPLICIT NONE

    REAL(4):: t1,t2
    INTEGER(ikind):: nt,ierr

    CALL GUTIME(t1)

    DO NT = 1, NTMAX ! main loop

       T=T+DT
       CALl tr_save_pvprev

       CALL tr_step(ierr)
       if(ierr /= 0) GO TO 9000

    END DO

9000 CONTINUE

    CALL GUTIME(t2)

    write(6,'(A,1PF12.3,A)') '## cputime = ',T2 - T1,' (s)'

  END SUBROUTINE tr_loop

! ***** save plasma variables to previous values *****

  SUBROUTINE tr_save_pvprev

    USE trcomm,ONLY: ikind,rkind,nrmax,nsamax, &
         qp,rn,ru,rt,qp_prev,rn_prev,ru_prev,rt_prev
    IMPLICIT NONE

    qp_prev(0:nrmax)=qp(0:nrmax)
    rn_prev(1:nsamax,0:nrmax)=rn(1:nsamax,0:nrmax)
    ru_prev(1:nsamax,0:nrmax)=ru(1:nsamax,0:nrmax)
    rt_prev(1:nsamax,0:nrmax)=rt(1:nsamax,0:nrmax)

    RETURN
  END SUBROUTINE tr_save_pvprev

END MODULE trloop
