C     $Id: wrgout.f,v 1.23 2013/01/20 23:24:03 fukuyama Exp $

C*********************** GRAPHIC DATA ************************
C
      SUBROUTINE WRGOUT(NSTAT)
C
      USE plcomm
      INCLUDE 'wrcomm.inc'
C
      CHARACTER KID*1
C
    1 WRITE(6,*)'INPUT GRAPH TYPE : 1,2,3,4,5,6  X'
      READ(5,'(A1)',ERR=1,END=9000) KID
      CALL GUCPTL(KID)
C
      IF(KID.EQ.'1'.AND.NSTAT.GE.1) CALL WRGRFA
      IF(KID.EQ.'2'.AND.NSTAT.GE.1) CALL WRGRFB
      IF(KID.EQ.'3'.AND.NSTAT.GE.1) CALL WRGRFC
      IF(KID.EQ.'4'.AND.NSTAT.GE.2) CALL WRGRFD
      IF(KID.EQ.'5'.AND.NSTAT.GE.2) CALL WRGRFE
      IF(KID.EQ.'6'.AND.NSTAT.GE.2) CALL WRGRFF
      IF(KID.EQ.'7'.AND.NSTAT.GE.2) CALL WRGRFG
      IF(KID.EQ.'X') GOTO 9000
C
      GOTO 1
C
 9000 RETURN
      END
C
C     ***** POLOIDAL TRAJECTORY AND POWER *****
C
      SUBROUTINE WRGRFA
C
      USE plcomm
      USE plprof,ONLY:PL_RZSU,PL_MAG_OLD
      INCLUDE 'wrcomm.inc'
C
      PARAMETER(NSUM=501)
      PARAMETER(NGXL=101,NGYL=101)
C
      DIMENSION RSU(NSUM),ZSU(NSUM)
      DIMENSION GRS(NSUM+1),GZS(NSUM+1)
      DIMENSION GX(NITM+1),GY(NITM+1)
      DIMENSION GUX(NITM+1),GUY(NITM+1)
      DIMENSION GPX(NITM+1),GPY(NITM+1,NRAYM)
      DIMENSION GPRY(NITM+1,NRAYM)
      DIMENSION GCF(NGXL,NGYL),GCX(NGXL),GCY(NGYL)
      DIMENSION KA(2,NGXL,NGYL)
C
C     ----- PLASMA BOUNDARY -----
C
      CALL PL_RZSU(RSU,ZSU,NSUM,NSUMAX)
      DO NSU=1,NSUMAX
         GRS(NSU)=GUCLIP(RSU(NSU))
         GZS(NSU)=GUCLIP(ZSU(NSU))
      ENDDO
      GRS(NSUMAX+1)=GRS(1)
      GZS(NSUMAX+1)=GZS(1)
C
      CALL GMNMX1(GRS,1,NSUMAX,1,GRSMIN,GRSMAX)
      CALL GMNMX1(GZS,1,NSUMAX,1,GZSMIN,GZSMAX)
      CALL GQSCAL(GRSMIN,GRSMAX,GRMIN,GRMAX,GRSTEP)
      CALL GQSCAL(GZSMIN,GZSMAX,GZMIN,GZMAX,GZSTEP)


      GRORG=(INT(GRMIN/(2*GRSTEP))+1)*2*GRSTEP
C
      GRLEN=GRMAX-GRMIN
      GZLEN=GZMAX-GZMIN
      IF(1.5*GRLEN.GT.GZLEN) THEN
         GZMID=0.5*(GZMIN+GZMAX)
         GZMIN=GZMID-0.75*GRLEN
         GZMAX=GZMID+0.75*GRLEN
C         CALL GDEFIN(1.5,11.5,1.0,16.0,
C     &               GRMIN,GRMAX,GZMID-0.75*GRLEN,GZMID+0.75*GRLEN)
         
      ELSE
         GRMID=0.5*(GRMIN+GRMAX)
         GRMIN=GRMID-0.333*GZLEN
         GRMAX=GRMID+0.333*GZLEN
C         CALL GDEFIN(1.5,11.5,1.0,16.0,
C     &               GRMID-0.333*GZLEN,GRMID+0.333*GZLEN,GZMIN,GZMAX)
      ENDIF
         CALL GDEFIN(1.5,11.5,1.0,16.0,GRMIN,GRMAX,GZMIN,GZMAX)
C
      CALL PAGES
      CALL SETCHS(0.25,0.)
      CALL SETFNT(32)
      CALL SETLIN(0,2,7)
      CALL GFRAME
      CALL GSCALE(GRORG,  GRSTEP,0.0,  GZSTEP,0.1,9)
      CALL GVALUE(GRORG,2*GRSTEP,0.0,0.0,NGULEN(2*GRSTEP))
      CALL GVALUE(0.0,0.0,0.0,2*GZSTEP,NGULEN(2*GZSTEP))
      CALL SETLIN(0,2,4)
      CALL GPLOTP(GRS,GZS,1,NSUMAX+1,1,0,0,0)
C
      IF(MODELG.EQ.3.OR.MODELG.EQ.8) THEN
         DGX=DBLE(GRMAX-GRMIN)/(NGXL-1)
         DO NGX=1,NGXL
            GCX(NGX)=GRMIN+(NGX-1)*GUCLIP(DGX)
         ENDDO
         DGY=DBLE(GZMAX-GZMIN)/(NGYL-1)
         DO NGY=1,NGYL
            GCY(NGY)=GZMIN+(NGY-1)*GUCLIP(DGY)
         ENDDO
         DO NGY=1,NGYL
            ZL=DBLE(GCY(NGY))
            DO NGX=1,NGXL
               RL=DBLE(GCX(NGX))
               CALL PL_MAG_OLD(RL,0.D0,ZL,RHON)
               GCF(NGX,NGY)=GUCLIP(RHON)
            ENDDO
         ENDDO
         CALL CONTP2(GCF,GCX,GCY,NGXL,NGXL,NGYL,
     &               0.1,0.1,9,0,1,KA)
      ENDIF
C
C     ----- RAY TRAJECTORY -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            RL=SQRT(RAYS(1,IT,NRAY)**2+RAYS(2,IT,NRAY)**2)
            GX(IT+1)=GUCLIP(RL)
            GY(IT+1)=GUCLIP(RAYS(3,IT,NRAY))
         ENDDO
         CALL SETLIN(0,2,7-MOD(NRAY-1,5))
         CALL GPLOTP(GX,GY,1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
      CALL SETLIN(0,2,7)
C
C     ----- CALCULATE RADIAL DEPOSITION PROFILE -----
C
      DRHO=1.D0/NRZMAX
      DO NRZ=1,NRZMAX
         GPX(NRZ)=GUCLIP(NRZ*DRHO)
      ENDDO
      DO NRAY=1,NRAYMX
         DO NRZ=1,NRZMAX
             GPY(NRZ,NRAY)=0.0
             GPRY(NRZ,NRAY)=0.0
         ENDDO
      ENDDO

      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)-1
            XL=RAYS(1,IT,NRAY)
            YL=RAYS(2,IT,NRAY)
            ZL=RAYS(3,IT,NRAY)
            CALL PL_MAG_OLD(XL,YL,ZL,RHON1)
	    NRS1=INT(RHON1/DRHO)+1
            XL=RAYS(1,IT+1,NRAY)
            YL=RAYS(2,IT+1,NRAY)
            ZL=RAYS(3,IT+1,NRAY)
            CALL PL_MAG_OLD(XL,YL,ZL,RHON2)
            NRS2=INT(RHON2/DRHO)+1
            NDR=ABS(NRS2-NRS1)
            IF(NDR.EQ.0) THEN
               GPY(NRS1,NRAY)=GPY(NRS1,NRAY)+GUCLIP(RAYS(8,IT+1,NRAY))
            ELSE IF(NRS1.LT.NRS2) THEN
               SDR=(RHON2-RHON1)/DRHO
               DELP=RAYS(8,IT+1,NRAY)/SDR
               GPY(NRS1,NRAY)=GPY(NRS1,NRAY)
     &                       +GUCLIP((DBLE(NRS1)-RHON1/DRHO)*DELP)
               DO NR=NRS1+1,NRS2-1
                  GPY(NR,NRAY)=GPY(NR,NRAY)+GUCLIP(DELP)
               ENDDO
               GPY(NRS2,NRAY)=GPY(NRS2,NRAY)
     &                       +GUCLIP((RHON2/DRHO-DBLE(NRS2-1))*DELP)
            ELSE
               SDR=(RHON1-RHON2)/DRHO
               DELP=RAYS(8,IT+1,NRAY)/SDR
               GPY(NRS2,NRAY)=GPY(NRS2,NRAY)
     &                       +GUCLIP((DBLE(NRS2)-RHON2/DRHO)*DELP)
               DO NR=NRS2+1,NRS1-1
                  GPY(NR,NRAY)=GPY(NR,NRAY)+GUCLIP(DELP)
               ENDDO
               GPY(NRS1,NRAY)=GPY(NRS1,NRAY)
     &                       +GUCLIP((RHON1/DRHO-DBLE(NRS1-1))*DELP)
            ENDIF
C            WRITE(6,'(3I5,1P5E12.4))') 
C     &           IT,NRS1,NRS2,RHON1,RHON2,SDR,DELP,RAYS(8,IT+1,NRAY)
         ENDDO
C         WRITE(6,'(5(I3,1PE12.4))') (NRZ,GPY(NRZ,NRAY),NRZ=1,NRZMAX)
      ENDDO
C
      DO NRAY=1,NRAYMX
      DO NRZ=1,NRZMAX
         GPY(NRZ,NRAY)=GPY(NRZ,NRAY)
     &                 /GUCLIP(2*PI*(DBLE(NRZ)-0.5D0)*DRHO*DRHO)
       ENDDO
C         WRITE(6,'(5(I3,1PE12.4))') (NRZ,GPY(NRZ,NRAY),NRZ=1,NRZMAX)
      ENDDO
C
C     ----- weight of power for each ray-------
C
      IF(NRAYMX.EQ.1) THEN
         FACTA=0.D0
      ELSE
         FACTA=EXP(-1.D0)/(1.D0+EXP(-1.D0)*(NRAYMX/2))
      ENDIF
      FACTB=1.D0-FACTA*(NRAYMX/2)
      DO NRZ=1,NRZMAX
         DO NRAY=2,NRAYMX
            GPRY(NRZ,1)=GPRY(NRZ,1)+GPY(NRZ,NRAY)*FACTA
         ENDDO
            GPRY(NRZ,1)=GPRY(NRZ,1)+GPY(NRZ,1)*FACTB
      ENDDO
C
C     ----- draw deposition profile -----
C
      CALL GQSCAL(GUCLIP(RHOGMN),GUCLIP(RHOGMX),
     &           GXMIN,GXMAX,GXSTEP)
C
      CALL GMNMX2(GPY,NITM+1,1,NRZMAX,1,1,NRAYMX,1,GYMIN,GYMAX)
      CALL GQSCAL(GYMIN,GYMAX,GYSMIN,GYSMAX1,GYSCAL1)
      GYSMIN=0.0
      GYSMAX2=0.1 
      GYSCAL2=2.E-2
      GYSMAX=MAX(GYSMAX1,GYSMAX2)
      GYSCAL=MAX(GYSCAL1,GYSCAL2)
C
      CALL MOVE(13.5,16.1)
      CALL TEXT('ABS POWER',10)
      IF(MOD(MDLWRG/2,2).EQ.0) THEN
         CALL GDEFIN(13.5,23.5,9.0,16.0,0.0,GXMAX,0.0,GYSMAX)
         CALL SETLIN(0,2,7)
         CALL GFRAME
         CALL GSCALE(0.0,  GXSTEP,0.0,  GYSCAL,0.1,9)
         CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
         CALL GVALUE(0.0,0.0,0.0,GYSCAL,NGULEN(GYSCAL))
      ELSE
         CALL GDEFIN(13.5,23.5,9.0,16.0,GXMIN,GXMAX,0.0,GYSMAX)
         CALL SETLIN(0,2,7)
         CALL GFRAME
         GXORG=(INT(GXMIN/(2*GXSTEP))+1)*2*GXSTEP
         CALL GSCALE(GXORG,  GXSTEP,0.0,  GYSCAL,0.1,9)
         CALL GVALUE(GXORG,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
         CALL GVALUE(0.0,0.0,0.0,GYSCAL,NGULEN(GYSCAL))
      ENDIF
C      CALL SETLIN(0,0,4)
      DO NRAY=1,NRAYMX
         CALL SETLIN(0,2,7-MOD(NRAY-1,5))
         CALL GPLOTP(GPX,GPY(1,NRAY),1,NRZMAX,1,0,0,0)
      ENDDO
      CALL SETLIN(0,2,7)

C
C     ----- draw weight power ----
C
      CALL GMNMX1(GPRY(1,1),1,NRZMAX,1,GYMIN,GYMAX)
      CALL GQSCAL(GYMIN,GYMAX,GYSMIN,GYSMAX1,GYSCAL1)
      GYSMIN=0.0
      GYSMAX2=0.1 
      GYSCAL2=2.E-2
      GYSMAX=MAX(GYSMAX1,GYSMAX2)
      GYSCAL=MAX(GYSCAL1,GYSCAL2)
C
      CALL MOVE(13.5,8.1)
      CALL TEXT('ABS WEIGHT POWER',20)
      IF(MOD(MDLWRG/2,2).EQ.0) THEN
         CALL GDEFIN(13.5,23.5,1.0,8.0,0.0,GXMAX,0.0,GYSMAX)
         CALL SETLIN(0,2,7)
         CALL GFRAME
         CALL GSCALE(0.0,  GXSTEP,0.0,  GYSCAL,0.1,9)
         CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
         CALL GVALUE(0.0,0.0,0.0,GYSCAL,NGULEN(GYSCAL))
      ELSE
         CALL GDEFIN(13.5,23.5,1.0,8.0,GXMIN,GXMAX,0.0,GYSMAX)
         CALL SETLIN(0,2,7)
         CALL GFRAME
         GXORG=(INT(GXMIN/(2*GXSTEP))+1)*2*GXSTEP
         CALL GSCALE(GXORG,  GXSTEP,0.0,  GYSCAL,0.1,9)
         CALL GVALUE(GXORG,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
         CALL GVALUE(0.0,0.0,0.0,GYSCAL,NGULEN(GYSCAL))
      ENDIF
C      CALL SETLIN(0,0,4)
C      DO NRAY=1,NRAYMX
C         CALL SETLIN(0,2,7-MOD(NRAY-1,5))
         CALL GPLOTP(GPX,GPRY(1,1),1,NRZMAX,1,0,0,0)
C      ENDDO
C
C     ----- DRAW POWER FLUX -----
C      
C      GZSMIN=0.0
C      GZSMAX=1.1
C      GZSCAL=0.2
C
C      CALL MOVE(13.5,8.1)
C      CALL TEXT('POWER FLUX',10)
C      IF(MOD(MDLWRG/2,2).EQ.0) THEN
C         CALL GDEFIN(13.5,23.5,1.0,8.0,0.0,GXMAX,0.0,GZSMAX)
C         CALL SETLIN(0,2,7)
C         CALL GFRAME
C         CALL GSCALE(0.0,  GXSTEP,0.0,  GZSCAL,0.1,9)
C         CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
C         CALL GVALUE(0.0,0.0,0.0,GZSCAL,1)
C      ELSE
C         CALL GDEFIN(13.5,23.5,1.0,8.0,GXMIN,GXMAX,0.0,GXSMAX)
C         CALL SETLIN(0,2,7)
C         CALL GFRAME
C         GXORG=(INT(GXMIN/(2*GXSTEP))+1)*2*GXSTEP
C         CALL GSCALE(GXORG,  GXSTEP,0.0,  GZSCAL,0.1,9)
C         CALL GVALUE(GXORG,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
C         CALL GVALUE(0.0,0.0,0.0,GZSCAL,1)
C      ENDIF
C      DO NRAY=1,NRAYMX
C         DO IT=0,NITMAX(NRAY)
C            XL=RAYS(1,IT,NRAY)
C            YL=RAYS(2,IT,NRAY)
C            ZL=RAYS(3,IT,NRAY)
C            CALL PL_MAG_OLD(XL,YL,ZL,RHON)
C	    GUX(IT+1)=GUCLIP(RHON)
C            GUY(IT+1)=GUCLIP(RAYS(7,IT,NRAY))
C         ENDDO
C         CALL SETLIN(0,0,7-MOD(NRAY-1,5))
C         CALL GPLOTP(GUX,GUY,1,NITMAX(NRAY)+1,1,0,0,0)      
C      ENDDO
      CALL WRGPRM
      CALL PAGEE
      RETURN
      END
C
C     ***** RADIAL DEPENDENCE 1 *****
C
      SUBROUTINE WRGRFB
C
      USE plcomm
      USE plprof,ONLY:PL_MAG_OLD
      INCLUDE 'wrcomm.inc'
C
      PARAMETER(NSRM=101)
      DIMENSION GX(NITM+1),GY(NITM+1)
      DIMENSION GKX(NITM+1,NRAYM)
      DIMENSION GKY1(NITM+1,NRAYM),GKY2(NITM+1,NRAYM)
      DIMENSION GLCX(NSRM),GLCY(NSRM),GSCX(NSRM),GSCY(NSRM)
C
      CALL PAGES
      CALL SETFNT(32)
      CALL SETCHS(0.25,0.)
      CALL SETLIN(0,2,7)
C
C     ----- TOROIDAL CROSS SECTION -----
C
      NSRMAX=101
      RMAX=RR+RA
      RMIN=RR-RA
      DTH=2*PI/(NSRMAX-1)
      DO NSU=1,NSRMAX
         TH=DTH*(NSU-1)
         GLCX(NSU)=GUCLIP(RMAX*COS(TH))
         GLCY(NSU)=GUCLIP(RMAX*SIN(TH))
         GSCX(NSU)=GUCLIP(RMIN*COS(TH))
         GSCY(NSU)=GUCLIP(RMIN*SIN(TH))
      ENDDO
      IF(MOD(MDLWRG,2).EQ.0) THEN
         GRRMAX=GUCLIP(RMAX)
         CALL GQSCAL(-GRRMAX,GRRMAX,GXMIN,GXMAX,GXSTEP)
         CALL GQSCAL(-GRRMAX,GRRMAX,GYMIN,GYMAX,GYSTEP)
      ELSE
         CALL GQSCAL(GUCLIP(RR-RA),GUCLIP(RR+RA),GXMIN,GXMAX,GXSTEP)
         CALL GQSCAL(GUCLIP(  -RA),GUCLIP(   RA),GYMIN,GYMAX,GYSTEP)
         GXORG=(INT(GXMIN/(2*GXSTEP))+1)*2*GXSTEP
      ENDIF
C
      CALL GDEFIN(1.7,11.7,1.0,11.0,GXMIN,GXMAX,GYMIN,GYMAX)

      CALL SETLIN(0,2,7)
      CALL GFRAME
      IF(MOD(MDLWRG,2).EQ.0) THEN
         CALL GSCALE(0.0,GXSTEP,0.0,GYSTEP,0.1,9)
         CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
         CALL GVALUE(0.0,0.0,0.0,2*GYSTEP,NGULEN(2*GYSTEP))
      ELSE
         CALL GSCALE(GXORG,GXSTEP,0.0,GYSTEP,0.1,9)
         CALL GVALUE(GXORG,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
         CALL GVALUE(0.0,0.0,0.0,2*GYSTEP,NGULEN(2*GYSTEP))
      ENDIF
C
      CALL SETLIN(0,2,4)
      CALL GPLOTP(GLCX,GLCY,1,NSRMAX,1,0,0,0)
      CALL GPLOTP(GSCX,GSCY,1,NSRMAX,1,0,0,0)
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GX(IT+1)=GUCLIP(RAYS(1,IT,NRAY))
            GY(IT+1)=GUCLIP(RAYS(2,IT,NRAY))
         ENDDO
         CALL SETLIN(0,0,7-MOD(NRAY-1,5))
         CALL GPLOTP(GX,GY,1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
      CALL SETLIN(0,2,7)
C
C     ----- WAVE NUMBER -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            XL=RAYS(1,IT,NRAY)
            YL=RAYS(2,IT,NRAY)
            ZL=RAYS(3,IT,NRAY)
            CALL PL_MAG_OLD(XL,YL,ZL,RHON)
            CALL WRCALK(IT,NRAY,RKPARA,RKPERP)
            GKX( IT+1,NRAY)=GUCLIP(RHON)
            GKY1(IT+1,NRAY)=GUCLIP(RKPARA*VC
     &                             /(2*PI*RAYIN(1,NRAY)*1.D6))
            GKY2(IT+1,NRAY)=GUCLIP(RKPERP)
         ENDDO
      ENDDO
C
      CALL GQSCAL(0.0,1.0,GXMIN,GXMAX,GXSTEP)
      NRAY=1
         CALL GMNMX1(GKY1(1,NRAY),1,NITMAX(NRAY),1,GYMIN1,GYMAX1)
         CALL GMNMX1(GKY2(1,NRAY),1,NITMAX(NRAY),1,GYMIN2,GYMAX2)
      DO NRAY=2,NRAYMX
         CALL GMNMX1(GKY1(1,NRAY),1,NITMAX(NRAY),1,GYMIN,GYMAX)
         GYMIN1=MIN(GYMIN1,GYMIN)
         GYMAX1=MAX(GYMAX1,GYMAX)
         CALL GMNMX1(GKY2(1,NRAY),1,NITMAX(NRAY),1,GYMIN,GYMAX)
         GYMIN2=MIN(GYMIN2,GYMIN)
         GYMAX2=MAX(GYMAX2,GYMAX)
      ENDDO
C
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL MOVE(13.7,16.1)
      CALL TEXT('n-para',6)
      CALL GDEFIN(13.7,23.7,9.0,16.0,0.0,GXMAX,GYMIN,GYMAX)
      CALL SETLIN(0,2,7)
      CALL GFRAME
      GYORG=(INT(GYMIN/(2*GYSTEP))+1)*2*GYSTEP
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
      CALL GVALUE(0.0,0.0,GYORG,2*GYSTEP,NGULEN(2*GYSTEP))
C
      DO NRAY=1,NRAYMX
         CALL SETLIN(0,0,7-MOD(NRAY-1,5))
         CALL GPLOTP(GKX(1,NRAY),GKY1(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
      CALL SETLIN(0,2,7)
C
      CALL GQSCAL(GYMIN2,GYMAX2,GYMIN,GYMAX,GYSTEP)
      CALL MOVE(13.7,8.1)
      CALL TEXT('k-perp',6)
      CALL GDEFIN(13.7,23.7,1.0,8.0,0.0,GXMAX,GYMIN,GYMAX)
      CALL SETLIN(0,2,7)
      CALL GFRAME
      GYORG=(INT(GYMIN/(2*GYSTEP))+1)*2*GYSTEP
      CALL GSCALE(0.0,GXSTEP,GYORG,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
      CALL GVALUE(0.0,0.0,GYORG,2*GYSTEP,NGULEN(2*GYSTEP))
C
      DO NRAY=1,NRAYMX
         CALL SETLIN(0,0,7-MOD(NRAY-1,5))
         CALL GPLOTP(GKX(1,NRAY),GKY2(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
      CALL SETLIN(0,2,7)
C
      CALL WRGPRM
      CALL PAGEE
C
      RETURN
      END
C
C     ***** RADIAL DEPENDENCE 2 *****
C
      SUBROUTINE WRGRFC
C
      USE plcomm
      USE plprof,ONLY:PL_MAG_OLD
      INCLUDE 'wrcomm.inc'
C
      DIMENSION GKX(NITM+1,NRAYM)
      DIMENSION GKY(NITM+1,NRAYM)
C
      CALL PAGES
      CALL SETFNT(32)
      CALL SETCHS(0.25,0.)
      CALL SETLIN(0,2,7)
C
C     ----- X AXIS -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            XL=RAYS(1,IT,NRAY)
            YL=RAYS(2,IT,NRAY)
            ZL=RAYS(3,IT,NRAY)
            CALL PL_MAG_OLD(XL,YL,ZL,RHON)
            GKX( IT+1,NRAY)=GUCLIP(RHON)
         ENDDO
      ENDDO
      CALL GQSCAL(0.0,1.0,GXMIN,GXMAX,GXSTEP)
C
C     ----- Fig.1 -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            RL=SQRT(RAYS(1,IT,NRAY)**2+RAYS(2,IT,NRAY)**2)
            RKR  =( RAYS(4,IT,NRAY)*RAYS(1,IT,NRAY)
     &             +RAYS(5,IT,NRAY)*RAYS(2,IT,NRAY))/RL
            GKY( IT+1,NRAY)=GUCLIP(RKR)
         ENDDO
      ENDDO
      NRAY=1
         CALL GMNMX1(GKY(1,NRAY),1,NITMAX(NRAY)+1,1,GYMIN1,GYMAX1)
      DO NRAY=2,NRAYMX
         CALL GMNMX1(GKY(1,NRAY),1,NITMAX(NRAY)+1,1,GYMIN,GYMAX)
         GYMIN1=MIN(GYMIN1,GYMIN)
         GYMAX1=MAX(GYMAX1,GYMAX)
      ENDDO
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
C
      CALL MOVE(1.7,16.1)
      CALL TEXT('k-R',3)
      CALL GDEFIN(1.7,11.7,9.0,16.0,0.0,GXMAX,GYMIN,GYMAX)
      CALL SETLIN(0,2,7)
      CALL GFRAME
      GYORG=(INT(GYMIN/(2*GYSTEP))+1)*2*GYSTEP
      CALL GSCALE(0.0,GXSTEP,GYORG,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
      CALL GVALUE(0.0,0.0,GYORG,2*GYSTEP,NGULEN(2*GYSTEP))
      DO NRAY=1,NRAYMX
         CALL SETLIN(0,0,7-MOD(NRAY-1,5))
         CALL GPLOTP(GKX(1,NRAY),GKY(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
C
C     ----- Fig.2 -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            RKZ  =  RAYS(6,IT,NRAY)
            GKY( IT+1,NRAY)=GUCLIP(RKZ)
         ENDDO
      ENDDO
      NRAY=1
         CALL GMNMX1(GKY(1,NRAY),1,NITMAX(NRAY)+1,1,GYMIN1,GYMAX1)
      DO NRAY=2,NRAYMX
         CALL GMNMX1(GKY(1,NRAY),1,NITMAX(NRAY)+1,1,GYMIN,GYMAX)
         GYMIN1=MIN(GYMIN1,GYMIN)
         GYMAX1=MAX(GYMAX1,GYMAX)
      ENDDO
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
C
      CALL MOVE(13.7,16.1)
      CALL TEXT('k-Z',3)
      CALL GDEFIN(13.7,23.7,9.0,16.0,0.0,GXMAX,GYMIN,GYMAX)
      CALL SETLIN(0,2,7)
      CALL GFRAME
      GYORG=(INT(GYMIN/(2*GYSTEP))+1)*2*GYSTEP
      CALL GSCALE(0.0,GXSTEP,GYORG,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
      CALL GVALUE(0.0,0.0,GYORG,2*GYSTEP,NGULEN(2*GYSTEP))
      DO NRAY=1,NRAYMX
         CALL SETLIN(0,0,7-MOD(NRAY-1,5))
         CALL GPLOTP(GKX(1,NRAY),GKY(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
C
C     ----- Fig.3 -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            RL=SQRT(RAYS(1,IT,NRAY)**2+RAYS(2,IT,NRAY)**2)
            RKPHI=(-RAYS(4,IT,NRAY)*RAYS(2,IT,NRAY)
     &             +RAYS(5,IT,NRAY)*RAYS(1,IT,NRAY))/RL
            GKY( IT+1,NRAY)=GUCLIP(RKPHI)
         ENDDO
      ENDDO
      NRAY=1
         CALL GMNMX1(GKY(1,NRAY),1,NITMAX(NRAY)+1,1,GYMIN1,GYMAX1)
      DO NRAY=2,NRAYMX
         CALL GMNMX1(GKY(1,NRAY),1,NITMAX(NRAY)+1,1,GYMIN,GYMAX)
         GYMIN1=MIN(GYMIN1,GYMIN)
         GYMAX1=MAX(GYMAX1,GYMAX)
      ENDDO
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
C
      CALL MOVE(1.7,8.1)
      CALL TEXT('k-phi',5)
      CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,GYMIN,GYMAX)
      CALL SETLIN(0,2,7)
      CALL GFRAME
      GYORG=(INT(GYMIN/(2*GYSTEP))+1)*2*GYSTEP
      CALL GSCALE(0.0,GXSTEP,GYORG,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
      CALL GVALUE(0.0,0.0,GYORG,2*GYSTEP,NGULEN(2*GYSTEP))
      DO NRAY=1,NRAYMX
         CALL SETLIN(0,0,7-MOD(NRAY-1,5))
         CALL GPLOTP(GKX(1,NRAY),GKY(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
C
C     ----- Fig.4 -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            RNPHI=(-RAYS(4,IT,NRAY)*RAYS(2,IT,NRAY)
     &             +RAYS(5,IT,NRAY)*RAYS(1,IT,NRAY))
            GKY( IT+1,NRAY)=GUCLIP(RNPHI)
         ENDDO
      ENDDO
      NRAY=1
         CALL GMNMX1(GKY(1,NRAY),1,NITMAX(NRAY)+1,1,GYMIN1,GYMAX1)
      DO NRAY=2,NRAYMX
         CALL GMNMX1(GKY(1,NRAY),1,NITMAX(NRAY)+1,1,GYMIN,GYMAX)
         GYMIN1=MIN(GYMIN1,GYMIN)
         GYMAX1=MAX(GYMAX1,GYMAX)
      ENDDO
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
C
      CALL MOVE(13.7,8.1)
      CALL TEXT('R*k-phi',7)
      CALL GDEFIN(13.7,23.7,1.0,8.0,0.0,GXMAX,GYMIN,GYMAX)
      CALL SETLIN(0,2,7)
      CALL GFRAME
      GYORG=(INT(GYMIN/(2*GYSTEP))+1)*2*GYSTEP
      CALL GSCALE(0.0,GXSTEP,GYORG,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,NGULEN(2*GXSTEP))
      CALL GVALUE(0.0,0.0,GYORG,2*GYSTEP,NGULEN(2*GYSTEP))
      DO NRAY=1,NRAYMX
         CALL SETLIN(0,0,7-MOD(NRAY-1,5))
         CALL GPLOTP(GKX(1,NRAY),GKY(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
C
      CALL WRGPRM
      CALL PAGEE
      RETURN
      END
C
C     ***** BEAM AND POWER *****
C
      SUBROUTINE WRGRFD
C
      USE libspf,ONLY: erf0
      USE plcomm
      USE plprof,ONLY:PL_MAG_OLD
      INCLUDE 'wrcomm.inc'
C
      DIMENSION GPX(NITM+1),GPY(NITM+1,NRAYM)
      DIMENSION GKX(NITM+1,NRAYM)
      DIMENSION GKY(NITM+1,NRAYM*2)
      DIMENSION FRLRO1(0:NRADMX+1),FZLRO1(0:NRADMX+1)
      DIMENSION FRLRO2(0:NRADMX+1),FZLRO2(0:NRADMX+1)
      DIMENSION GPAY(NITM+1,NRAYM)
      DIMENSION RLMA1(0:NITM+1,0:NRADMX),ZLMA1(0:NITM+1,0:NRADMX)
      DIMENSION RLMA2(0:NITM+1,0:NRADMX),ZLMA2(0:NITM+1,0:NRADMX)
      DIMENSION FASSX1(0:NITM+1,0:NRADMX),FASSZ1(0:NITM+1,0:NRADMX)
      DIMENSION DELP1(0:NITM+1,0:NRADMX),DELP2(0:NITM+1,0:NRADMX)
      DIMENSION FASSX2(0:NITM+1,0:NRADMX),FASSZ2(0:NITM+1,0:NRADMX)
C
      CALL PAGES
      CALL SETFNT(32)
      CALL SETCHS(0.25,0.)
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C
C     ----- X AXIS -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            XL=RAYS(1,IT,NRAY)
            YL=RAYS(2,IT,NRAY)
            ZL=RAYS(3,IT,NRAY)
            CALL PL_MAG_OLD(XL,YL,ZL,RHON)
            GKX( IT+1,NRAY)=GUCLIP(RHON)
C            GKX( IT+1,NRAY)=GUCLIP(RAYB(0,IT))
         ENDDO
      ENDDO
C
      CALL GMNMX1(GKX,1,NITMAX(1),1,GXMIN1,GXMAX1)
      CALL GQSCAL(0.0,GXMAX1,GXMIN,GXMAX,GXSTEP)
C
C     ----- Fig.1  R-CURV-----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GKY( IT+1,1)=GUCLIP(RAYB(21,IT))
            GKY( IT+1,2)=GUCLIP(RAYB(22,IT))
         ENDDO
      ENDDO
C
      CALL SETRGB(0.0,0.0,0.0)
C     CALL SETLNW(0.035)
      CALL SETLIN(0,2,7)
      CALL MOVE(1.7,16.1)
      CALL TEXT('R-curv',6)
      CALL GDEFIN(1.7,11.7,9.0,16.0,0.0,GXMAX,-6.0,6.0)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,0.0,2.0,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,2.0,1)
      CALL SETRGB(0.0,0.0,1.0)
      CALL GPLOTP(GKX,GKY(1,1),1,NITMAX(1)+1,1,0,0,0)
      CALL SETRGB(1.0,0.0,0.0)
      CALL GPLOTP(GKX,GKY(1,2),1,NITMAX(1)+1,1,0,0,0)
      CALL SETRGB(0.0,0.0,0.0)
C
C     ----- Fig.2   R-BEAM-----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GKY( IT+1,1)=GUCLIP(RAYB(23,IT))
            GKY( IT+1,2)=GUCLIP(RAYB(24,IT))
         ENDDO
      ENDDO
C
      CALL MOVE(1.7,8.1)
      CALL SETRGB(0.0,0.0,0.0)
      CALL TEXT('R-beam',6)
C      CALL GMNMX1(GKY(1,1),1,NITMAX(1),1,GYMINA,GYMAXA)
C      CALL GMNMX1(GKY(1,2),1,NITMAX(1),1,GYMINB,GYMAXB)
C      GYMIN1=MIN(GYMINA,GYMINB)
C      GYMAX1=MAX(GYMAXA,GYMAXB)     
      CALL GQSCAL (GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
C      CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,GYMIN,GYMAX)
      CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,0.0,0.10)
      CALL SETLIN(0,2,7)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,0.0,0.01,0.1,9)
C      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
C      CALL GVALUE(0.0,2*GXSTEP,GYMIN,GYSTEP,2)
      CALL GVALUE(0.0,2*GXSTEP,0.0,0.01,2)
      CALL SETRGB(0.0,0.0,1.0)
      CALL GPLOTP(GKX,GKY(1,1),1,NITMAX(1)+1,1,0,0,0)
      CALL SETRGB(1.0,0.0,0.0)
      CALL GPLOTP(GKX,GKY(1,2),1,NITMAX(1)+1,1,0,0,0)
      CALL SETRGB(0.0,0.0,0.0)
C
C      CALL MOVE(9.0,16.4)
C      CALL TEXT ('X1= ',3)
C      CALL NUMBR(GKX(K,1),'(F5.3)',5)
C      CALL MOVE(5.0,16.4)
C      CALL TEXT ('dMIN1= ',6)
C      CALL NUMBR(GKY(K,1),'(F9.7)',9)
C
C      CALL MOVE(9.0,16.0)
C      CALL TEXT ('X2= ',3)
C      CALL NUMBR(GKX(K,1),'(F5.3)',5)
C      CALL MOVE(5.0,16.0)
C      CALL TEXT ('dMIN2= ',6)
C      CALL NUMBR(GKY(K,2),'(F9.7)',9)
C
      CALL MOVE(1.0,16.4)
      CALL TEXT ('SMAX= ',6)
      CALL NUMBD(smax,'(F5.2)',5)
      CALL MOVE(11.0,16.0)
      CALL TEXT ('RCURV= ',6)
      CALL NUMBD(RCURVA,'(F5.2)',5)
      CALL MOVE(11.0,16.4)
      CALL TEXT ('RBRAD= ',6)
      CALL NUMBD(RBRADA,'(F5.2)',5)
C
C     ----- Fig.3  Beam-Rot -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GKY(IT+1,1)=GUCLIP(RAYB(25,IT))
            GKY(IT+1,2)=GUCLIP(RAYB(26,IT))
C             GKY(IT+1,1)=GUCLIP(RAYB(20,IT))
         ENDDO
      ENDDO
C
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLIN(0,2,7)
      CALL MOVE(13.5,16.1)
      CALL TEXT('Beam-rot',8) 
      CALL GDEFIN(13.5,23.5,9.0,16.0,0.0,GXMAX,0.0,180.0)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,0.0,0.0,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,0.0,1)
      CALL GSCALE(0.0,0.0,0.0,30.0,0.1,9)
      CALL GVALUE(0.0,0.0,0.0,30.0,0)
      CALL SETRGB(0.0,0.0,1.0)
      CALL GPLOTP(GKX,GKY(1,1),1,NITMAX(1)+1,1,0,0,0)
      CALL SETRGB(1.0,0.0,0.0)
      CALL GPLOTP(GKX,GKY(1,2),1,NITMAX(1)+1,1,0,0,0)
      CALL SETRGB(0.0,0.0,0.0)
C
C
C     -------------------------------------------------------------------
C     ----- CALCULATE RADIAL DEPOSITION PROFILE (without beam radial)----
C     -------------------------------------------------------------------
      DRHO=1.D0/NRZMAX
      DO NRZ=1,NRZMAX
         GPX(NRZ)=GUCLIP(NRZ*DRHO)
      ENDDO
      DO NRAY=1,NRAYMX
         DO NRZ=1,NRZMAX
            GPY(NRZ,NRAY)=0.0
         ENDDO
      ENDDO
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)-1
            RLA =SQRT(RAYS(1,IT,NRAY)**2+RAYS(2,IT,NRAY)**2)
            ZLA =RAYS(3,IT,NRAY)
            CALL GETRZ(RLA,ZLA,PHIL,BR,BZ,BPHI,RHON1)
C            XL=RAYS(1,IT,NRAY)
C            YL=RAYS(2,IT,NRAY)
C            ZL=RAYS(3,IT,NRAY)
C            CALL PL_MAG_OLD(XL,YL,ZL,RHON1)
	    NRS1=INT(RHON1/DRHO)+1
            RLAD=SQRT(RAYS(1,IT+1,NRAY)**2+RAYS(2,IT+1,NRAY)**2)
            ZLAD=RAYS(3,IT+1,NRAY)
            CALL GETRZ(RLAD,ZLAD,PHIL,BR,BZ,BPHI,RHON2)            
C            XL=RAYS(1,IT+1,NRAY)
C            YL=RAYS(2,IT+1,NRAY)
C            ZL=RAYS(3,IT+1,NRAY)
C            CALL PL_MAG_OLD(XL,YL,ZL,RHON2)
            NRS2=INT(RHON2/DRHO)+1
            NDR=ABS(NRS2-NRS1)
C
            IF(NDR.EQ.0) THEN
               GPY(NRS1,NRAY)=GPY(NRS1,NRAY)+GUCLIP(RAYS(8,IT+1,NRAY))
            ELSE IF(NRS1.LT.NRS2) THEN
               SDR=(RHO2-RHO1)/DRHO
               DELP=RAYS(8,IT+1,NRAY)/SDR
               GPY(NRS1,NRAY)=GPY(NRS1,NRAY)
     &                       +GUCLIP((DBLE(NRS1)-RHO1/DRHO)*DELP)              
               DO NR=NRS1+1,NRS2-1
                  GPY(NR,NRAY)=GPY(NR,NRAY)+GUCLIP(DELP)
               ENDDO
               GPY(NRS2,NRAY)=GPY(NRS2,NRAY)
     &                       +GUCLIP((RHO2/DRHO-DBLE(NRS2-1))*DELP)
            ELSE
               SDR=(RHO1-RHO2)/DRHO
               DELP=RAYS(8,IT+1,NRAY)/SDR
               GPY(NRS2,NRAY)=GPY(NRS2,NRAY)
     &                       +GUCLIP((DBLE(NRS2)-RHO2/DRHO)*DELP)
               DO NR=NRS2+1,NRS1-1
                  GPY(NR,NRAY)=GPY(NR,NRAY)+GUCLIP(DELP)
               ENDDO
               GPY(NRS1,NRAY)=GPY(NRS1,NRAY)
     &                       +GUCLIP((RHO1/DRHO-DBLE(NRS1-1))*DELP)
            ENDIF
            ENDDO
C         WRITE(6,'(5(I3,1PE12.4))') (NRZ,GPY(NRZ,NRAY),NRZ=1,NRZMAX)
      ENDDO
C
      DO NRAY=1,NRAYMX
      DO NRZ=1,NRZMAX
         GPY(NRZ,NRAY)=GPY(NRZ,NRAY)
     &                 /GUCLIP(2*PI*(DBLE(NRZ)-0.5D0)*DRHO*DRHO)
      ENDDO
C         WRITE(6,'(5(I3,1PE12.4))') (NRZ,GPY(NRZ,NRAY),NRZ=1,NRZMAX)
      ENDDO
c
C
C     -------------------------------------------------------------------
C     ----- CALCULATE RADIAL DEPOSITION PROFILE (with beam radial)-------
C     -------------------------------------------------------------------
C
      IF (MODELG.EQ.3.OR.MODELG.EQ.8) THEN
       DRHO=1.D0/NRZMAX  
      DO NRAY=1,NRAYMX
         DO NRZ=1,NRZMAX
            GPX (NRZ)=GUCLIP(NRZ*DRHO)
            GPAY(NRZ,NRAY)=0.0
         ENDDO
      ENDDO
C    
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)-1
            DRAD=1.D0/DBLE(NRADMX)
C        ---------------------------------------------------------
C
C        ----- CALC SLOPE OF RAY TRAJECTORY-----------------------
            RLA =SQRT(RAYS(1,IT,NRAY)**2+RAYS(2,IT,NRAY)**2)
            RLAD=SQRT(RAYS(1,IT+1,NRAY)**2+RAYS(2,IT+1,NRAY)**2)
            ZLA =RAYS(3,IT ,NRAY)
            ZLAD=RAYS(3,IT+1,NRAY)
            DRL=RLAD-RLA
            DZL=ZLAD-ZLA
C        ---------------------------------------------------------
C
C        -----(i)ROTATE DRL and DZL (90 Degree)-------------------
            DRLS=-DZL
            DZLS= DRL
            DABSS=SQRT(DRLS**2+DZLS**2)
            DRLSN=DRLS/DABSS
            DZLSN=DZLS/DABSS
C        ---------------------------------------------------------
C
C        ----- JUDGE MAGNETIC SURFACE-----------------------------
            DO NRAD=0,NRADMX
               FRLRO1(NRAD)=RLA+NRAD*DRAD*DRLSN*RAYB(23,IT)
               FZLRO1(NRAD)=ZLA+NRAD*DRAD*DZLSN*RAYB(23,IT)
            ENDDO
C            ---------------------------------------------
C
C            ------ REFERENCE DIRECTION ------------------
C               CALL GETRZ(RLA,ZLA,PHIL,BR,BZ,BPHI,PSINR)
C               RHOR=SQRT(PSINR)
C               NRSR=INT(RHOR/DRHO)+1
C               CALL GETRZ(RLAD,ZLAD,PHIL,BR,BZ,BPHI,PSINDR)
C               RHODR=SQRT(PSINDR)
C               NRSDR=INT(RHODR/DRHO)+1
C            ---------------------------------------------
C            
C            ------ BEAM RADIAL DIRECTION ----------------
               RLDMAX1=FRLRO1(NRADMX)
               ZLDMAX1=FZLRO1(NRADMX)
               CALL GETRZ(RLDMAX1,ZLDMAX1,PHIL,BR,BZ,BPHI,PSINDMAX1)
               RHOMAX1=SQRT(PSINDMAX1)
               NRSMAX1=INT(RHOMAX1/DRHO)+1
               CALL GETRZ(RLA,ZLA,PHIL,BR,BZ,BPHI,PSINDMIN1)
               RHOMIN1=SQRT(PSINDMIN1)
               NRSMIN1=INT(RHOMIN1/DRHO)+1
               NDBRD1=(NRSMAX1-NRSMIN1)
               NABSM1=ABS(NDBRD1)
C
               
           DO NRAD=0,NRADMX-1
               RL1=FRLRO1(NRAD)
               ZL1=FZLRO1(NRAD)
               CALL GETRZ(RL1,ZL1,PHIL,BR,BZ,BPHI,PSIN1)
               RHO1=SQRT(PSIN1)
               NRSA1=INT(RHO1/DRHO)+1
C
               RLD1=FRLRO1(NRAD+1)
               ZLD1=FZLRO1(NRAD+1)
               CALL GETRZ(RLD1,ZLD1,PHIL,BR,BZ,BPHI,PSIND1)
               RHOD1=SQRT(PSIND1)
               NRSDA1=INT(RHOD1/DRHO)+1
C
                IF (NRSDA1.NE.NRSA1) THEN
                   RLMA1(IT,ABS(NRSDA1-NRSMIN1))=RL1
                   ZLMA1(IT,ABS(NRSDA1-NRSMIN1))=ZL1
                ENDIF
            ENDDO
C           
            IF (NDBRD1.EQ.0) THEN
               GPAY(NRSMIN1,NRAY)=GPAY(NRSMIN1,NRAY)
     &                        +0.5*GUCLIP(RAYS(8,IT+1,NRAY))
            ELSE IF (NDBRD1.LT.0) THEN 
               RLMA1(IT,0)=RLA
               ZLMA1(IT,0)=ZLA
               DO NCS=1,NABSM1
               SIGMA=RAYB(23,IT)/3.D0
C               SIGMA=5.D0*RAYB(23,IT)
               FASSX1(IT,NCS)=SQRT((RLMA1(IT,NCS)-RLA)**2
     &                            +(ZLMA1(IT,NCS)-ZLA)**2)
C               FASSZ1(IT,NCS)=FASSX1(IT,NCS)/RAYB(23,IT)
               FASSZ1(IT,NCS)=FASSX1(IT,NCS)/SIGMA
               DELP1(IT,NCS)=ERF0(FASSZ1(IT,NCS))
     &                      -ERF0(FASSZ1(IT,NCS-1))
C               WRITE(6,*) DELP1(IT,NCS)
               GPAY(NRSMIN1-NCS+1,NRAY)=GPAY(NRSMIN1-NCS+1,NRAY)
     &                   +0.5*GUCLIP(RAYS(8,IT+1,NRAY)*DELP1(IT,NCS))
               ENDDO
               GPAY(NRSMAX1,NRAY)=GPAY(NRSMAX1,NRAY)
     &                  +GUCLIP(0.5D0-0.5D0*ERF0(FASSZ1(IT,NABSM1)))
     &                  *GUCLIP(RAYS(8,IT+1,NRAY))
C             
            ELSE 
               RLMA1(IT,0)=RLA
               ZLMA1(IT,0)=ZLA
               DO NCS=1,NABSM1
               SIGMA=RAYB(23,IT)/3.D0
               FASSX1(IT,NCS)=SQRT((RLMA1(IT,NCS)-RLA)**2
     &                           +(ZLMA1(IT,NCS)-ZLA)**2)
C               FASSZ1(IT,NCS)=FASSX1(IT,NCS)/RAYB(23,IT)
               FASSZ1(IT,NCS)=FASSX1(IT,NCS)/SIGMA
               DELP1(IT,NCS)=ERF0(FASSZ1(IT,NCS))
     &                      -ERF0(FASSZ1(IT,NCS-1))
C               WRITE(6,*) DELP1(IT,NCS)
               GPAY(NRSMIN1+NCS-1,NRAY)=GPAY(NRSMIN1+NCS-1,NRAY)
     &                   +0.5*GUCLIP(RAYS(8,IT+1,NRAY)*DELP1(IT,NCS))
               ENDDO
               GPAY(NRSMAX1,NRAY)=GPAY(NRSMAX1,NRAY)
     &                  +0.5*GUCLIP(1.0D0-ERF0(FASSZ1(IT,NABSM1)))
     &                  *GUCLIP(RAYS(8,IT+1,NRAY))
            ENDIF
            
C      ------------------------------------------------------
C
C      -----(ii)ROTATE DRLS and DZLS (-90 Degree)
            DRLT= DZL
            DZLT=-DRL
            DABST=SQRT(DRLT**2+DZLT**2)
            DRLTN=DRLT/DABST
            DZLTN=DZLT/DABST
C      ------------------------------------------------------
C
C      ------ JUDGE MAGNETIC SURFACE ------------------------
            DO NRAD=0,NRADMX
               FRLRO2(NRAD)=RLA+NRAD*DRAD*DRLTN*RAYB(23,IT)
               FZLRO2(NRAD)=ZLA+NRAD*DRAD*DZLTN*RAYB(23,IT)
            ENDDO
C
               RLDMAX2=FRLRO2(NRADMX)
               ZLDMAX2=FZLRO2(NRADMX)
               CALL GETRZ(RLDMAX2,ZLDMAX2,PHIL,BR,BZ,BPHI,PSINDMAX2)
               RHOMAX2=SQRT(PSINDMAX2)
               NRSMAX2=INT(RHOMAX2/DRHO)+1
               CALL GETRZ(RLA,ZLA,PHIL,BR,BZ,BPHI,PSINDMIN2)
               RHOMIN2=SQRT(PSINDMIN2)
               NRSMIN2=INT(RHOMIN2/DRHO)+1
               NDBRD2=(NRSMAX2-NRSMIN2)
               NABSM2=ABS(NDBRD2)
C
            DO NRAD=0,NRADMX-1
               RL2=FRLRO2(NRAD)
               ZL2=FZLRO2(NRAD)
               CALL GETRZ(RL2,ZL2,PHIL,BR,BZ,BPHI,PSIN2)
               RHO2=SQRT(PSIN2)
               NRSA2=INT(RHO2/DRHO)+1
C
               RLD2=FRLRO2(NRAD+1)
               ZLD2=FZLRO2(NRAD+1)
               CALL GETRZ(RLD2,ZLD2,PHIL,BR,BZ,BPHI,PSIND2)
               RHOD2=SQRT(PSIND2)
               NRSDA2=INT(RHOD2/DRHO)+1
C            
               IF (NRSDA2.NE.NRSA2) THEN
                     RLMA2(IT,ABS(NRSDA2-NRSMIN2))=RL2
                     ZLMA2(IT,ABS(NRSDA2-NRSMIN2))=ZL2
               ENDIF
            ENDDO
C 
            IF (NDBRD2.EQ.0) THEN
               GPAY(NRSMIN2,NRAY)=GPAY(NRSMIN2,NRAY)
     &                        +0.5*GUCLIP(RAYS(8,IT+1,NRAY))
            ELSE IF (NDBRD2.LT.0) THEN
               RLMA2(IT,0)=RLA
               ZLMA2(IT,0)=ZLA
               DO NCS2=1,NABSM2
               SIGMA=RAYB(23,IT)/3.D0
C               SIGMA=5.D0*RAYB(23,IT)
               FASSX2(IT,NCS2)=SQRT((RLMA2(IT,NCS2)-RLA)**2
     &                          +(ZLMA2(IT,NCS2)-ZLA)**2)
C               FASSZ2(IT,NCS2)=FASSX2(IT,NCS2)/RAYB(23,IT)
               FASSZ2(IT,NCS2)=FASSX2(IT,NCS2)/SIGMA
               DELP2(IT,NCS2)=ERF0(FASSZ2(IT,NCS2))
     &                       -ERF0(FASSZ2(IT,NCS2-1))
               GPAY(NRSMIN2-NCS2+1,NRAY)=GPAY(NRSMIN2-NCS2+1,NRAY)
     &              +0.5*GUCLIP(RAYS(8,IT+1,NRAY)*DELP2(IT,NCS2))
               ENDDO
               GPAY(NRSMAX2,NRAY)=GPAY(NRSMAX2,NRAY)
     &                  +(0.5-0.5*GUCLIP(ERF0(FASSZ2(IT,NABSM2))))
     &                  *GUCLIP(RAYS(8,IT+1,NRAY))
            ELSE
               RLMA2(IT,0)=RLA
               ZLMA2(IT,0)=ZLA
               DO NCS2=1,NABSM2
               SIGMA=RAYB(23,IT)/3.D0
C                SIGMA=5.D0*RAYB(23,IT)
               FASSX2(IT,NCS2)=SQRT((RLMA2(IT,NCS2)-RLA)**2
     &                             +(ZLMA2(IT,NCS2)-ZLA)**2)
C               FASSZ2(IT,NCS2)=FASSX2(IT,NCS2)/RAYB(23,IT)
                FASSZ2(IT,NCS2)=FASSX2(IT,NCS2)/SIGMA
               DELP2(IT,NCS2)=ERF0(FASSZ2(IT,NCS2))
     &                       -ERF0(FASSZ2(IT,NCS2-1))
               GPAY(NRSMIN2+NCS2-1,NRAY)=GPAY(NRSMIN2+NCS2-1,NRAY)
     &                   +0.5*GUCLIP(RAYS(8,IT+1,NRAY)*delp2(it,ncs2))
               ENDDO
               GPAY(NRSMAX2,NRAY)=GPAY(NRSMAX2,NRAY)
     &                  +(0.5-0.5*GUCLIP(ERF0(FASSZ2(IT,NABSM2))))
     &                  *GUCLIP(RAYS(8,IT+1,NRAY))
            ENDIF
         ENDDO
      ENDDO
C
C
      DO NRAY=1,NRAYMX
         DO NRZ=1,NRZMAX
            GPAY(NRZ,NRAY)=GPAY(NRZ,NRAY)
     &                 /GUCLIP(2*PI*(DBLE(NRZ)-0.5D0)*DRHO*DRHO)
         ENDDO
C         WRITE(6,'(5(I3,1PE12.4))') (NRZ,GPAY(NRZ,NRAY),NRZ=1,NRZMAX)
      ENDDO
      ENDIF
c     -----Fig.4 draw deposition profile -----
c
      IF(MOD(MDLWRG/2,2).EQ.0) THEN
         CALL GQSCAL(0.0,1.0,GXMIN,GXMAX,GXSTEP)
      ELSE
         CALL GQSCAL(GUCLIP(RHOGMN),GUCLIP(RHOGMX),
     &        GXMIN,GXMAX,GXSTEP)
      ENDIF
c
      CALL GMNMX2(GPY,NITM+1,1,NRZMAX,1,1,NRAYMX,1,GYMIN,GYMAX)
      CALL GQSCAL(GYMIN,GYMAX,GYSMIN,GYSMAX1,GYSCAL1)
      GYSMIN=0.0
      GYSMAX2=0.1 
      GYSCAL2=2.E-2
      GYSMAX=MAX(GYSMAX1,GYSMAX2)
      GYSCAL=MAX(GYSCAL1,GYSCAL2)
C
      CALL MOVE(13.5,8.1)
      CALL TEXT('ABS POWER',10)
C      CALL GDEFIN(13.5,23.5,1.0,8.0,0.0,GXMAX,GYSMIN,GYSMAX)
      CALL GDEFIN(13.5,23.5,1.0,8.0,GXMIN,GXMAX,GYSMIN,GYSMAX)
      CALL SETRGB(0.0,0.0,0.0)
      CALL GFRAME
      CALL GSCALE(GXMIN,GXSTEP,GYSMIN,GYSCAL,0.1,9)      
      CALL GVALUE(GXMIN,2*GXSTEP,GYSMIN,GYSCAL,2)
C      CALL SETLIN(0,0,4)
      DO NRAY=1,NRAYMX
         CALL SETLIN(0,2,7-MOD(NRAY-1,5))
         CALL GPLOTP(GPX,GPY(1,NRAY),1,NRZMAX,1,0,0,0)
         CALL SETRGB(0.0,0.0,0.0)
      ENDDO
C
      DO NRAY=1,NRAYMX
         CALL SETLIN(0,2,7-MOD(NRAY,5))
         CALL GPLOTP(GPX,GPAY(1,NRAY),1,NRADMX,1,0,0,0)
         CALL SETRGB(1.0,0.0,0.0)
      ENDDO     
C
      CALL WRGPRM
      CALL PAGEE
      RETURN
      END
C
C     ***** Rays ***********
      SUBROUTINE WRGRFE
C
      USE plcomm
      USE plprof,ONLY:PL_MAG_OLD
      INCLUDE 'wrcomm.inc'
C
      DIMENSION GSX (NITM+1,NRAYM),GRX (NITM+1,NRAYM)
      DIMENSION GKY1(NITM+1,NRAYM),GKY2(NITM+1,NRAYM)
C
      CALL PAGES
      CALL SETFNT(32)
      CALL SETCHS(0.25,0.)
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C
C    ------- X Axis (direction along ray reference)-------
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GSX(IT+1,NRAY)=GUCLIP(RAYS(0,IT,NRAY))
         ENDDO
         CALL GMNMX1(GSX(1,1),1,NITMAX(1),1,GXMIN1,GXMAX1)
         CALL GMNMX1(GSX(1,NRAY),1,NITMAX(NRAY),1,GXMIN,GXMAX)
         GXMAX1=MAX(GXMAX1,GXMAX)
      ENDDO
C
      CALL GQSCAL(0.0,GXMAX1,GXMIN,GXMAX,GXSTEP)
C
C      ------ NRAY BEAM WIDTH 1 -------
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GKY1(IT+1,NRAY)=GUCLIP(RAYRB1(IT,NRAY))
         ENDDO
         CALL GMNMX1(GKY1(1,1),1,NITMAX(1),1,GYMIN1,GYMAX1)
         CALL GMNMX1(GKY1(1,NRAY),1,NITMAX(NRAY),1,GYMIN,GYMAX)
         GYMAX1=MAX(GYMAX1,GYMAX)
         GYMIN1=MIN(GYMIN1,GYMIN)
      ENDDO
C
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL MOVE(1.7,16.1)
      CALL TEXT('S-Beam1',7)
      CALL GDEFIN(1.7,11.7,9.0,16.0,0.0,GXMAX,0.0,GYMAX)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,2*GYSTEP,2)

C
      DO NRAY=1,NRAYM
      CALL SETLIN(0,2,7-MOD(NRAY-1,5))
      CALL GPLOTP(GSX(1,NRAY),GKY1(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
C
C            ------ NRAY BEAM WIDTH 2 -------
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GKY2(IT+1,NRAY)=GUCLIP(RAYRB2(IT,NRAY))
         ENDDO
         CALL GMNMX1(GKY2(1,1),1,NITMAX(1),1,GYMIN2,GYMAX2)
         CALL GMNMX1(GKY2(1,NRAY),1,NITMAX(NRAY),1,GYMIN,GYMAX)
         GYMAX2=MAX(GYMAX2,GYMAX)
         GYMIN2=MIN(GYMIN2,GYMIN)
      ENDDO
C
      CALL SETRGB(0.0,0.0,0.0)
      CALL GQSCAL(GYMIN2,GYMAX2,GYMIN,GYMAX,GYSTEP)
      CALL MOVE(13.5,16.1)
      CALL TEXT('S-Beam2',7)
      CALL GDEFIN(13.5,23.5,9.0,16.0,0.0,GXMAX,0.0,GYMAX)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,2*GYSTEP,2)
C
      DO NRAY=1,NRAYM
      CALL SETLIN(0,2,7-MOD(NRAY-1,5))
      CALL GPLOTP(GSX(1,NRAY),GKY2(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
C   
C    ------- X Axis (radial direction)-------
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            XL=RAYS(1,IT,NRAY)
            YL=RAYS(2,IT,NRAY)
            ZL=RAYS(3,IT,NRAY)
            CALL PL_MAG_OLD(XL,YL,ZL,RHON)
            GRX(IT+1,NRAY)=GUCLIP(RHON)
         ENDDO
         CALL GMNMX1(GRX(1,1),1,NITMAX(1),1,GXMIN1,GXMAX1)
         CALL GMNMX1(GRX(1,NRAY),1,NITMAX(NRAY),1,GXMIN,GXMAX)
         GXMAX1=MAX(GXMAX1,GXMAX)
      ENDDO
C
      CALL GQSCAL(0.0,GXMAX1,GXMIN,GXMAX,GXSTEP)
      
C
C     ------ NRAY BEAM WIDTH1 ----------------
C
      CALL SETRGB(0.0,0.0,0.0)
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL MOVE(1.7,8.1)
      CALL TEXT('R-Beam1',7)
      CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,0.0,GYMAX)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,2*GYSTEP,2)
C
      DO NRAY=1,NRAYM
      CALL SETLIN(0,2,7-MOD(NRAY-1,5))
      CALL GPLOTP(GRX(1,NRAY),GKY1(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
C
C     ------ NRAY BEAM WIDTH2 ----------------
C
      CALL SETRGB(0.0,0.0,0.0)
      CALL GQSCAL(GYMIN2,GYMAX2,GYMIN,GYMAX,GYSTEP)
      CALL MOVE(13.5,8.1)
      CALL TEXT('R-Beam2',7)
      CALL GDEFIN(13.5,23.5,1.0,8.0,0.0,GXMAX,0.0,GYMAX)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,0.0,2*GYSTEP,2)
C
      DO NRAY=1,NRAYM
      CALL SETLIN(0,2,7-MOD(NRAY-1,5))
      CALL GPLOTP(GRX(1,NRAY),GKY2(1,NRAY),1,NITMAX(NRAY)+1,1,0,0,0)
      ENDDO
C
      CALL PAGEE
      RETURN
      END
C
C     ***** ANGLE AND WS(I,J) *****
C
      SUBROUTINE WRGRFF
C
      USE plcomm
      USE plprof,ONLY:PL_MAG_OLD
      INCLUDE 'wrcomm.inc'
C
      DIMENSION GKX(NITM+1,1),GKY(NITM+1,2)
      DIMENSION GKSY(NITM+1,6),GKPY(NITM+1,6)
      DIMENSION GTHY(NITM+1,1)
C
      CALL PAGES
      CALL SETFNT(32)
      CALL SETCHS(0.25,0.)
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C
C     ----- X AXIS -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            XL=RAYS(1,IT,NRAY)
            YL=RAYS(2,IT,NRAY)
            ZL=RAYS(3,IT,NRAY)
            CALL PL_MAG_OLD(XL,YL,ZL,RHON)
            GKX( IT+1,NRAY)=GUCLIP(RAYB(0,IT))
         ENDDO
      ENDDO
C
C      CALL GMNMX1(GKX,1,NITMAX(1),1,GXMIN1,GXMAX1)
C      CALL GQSCAL(GKMIN1,GXMAX1,GXMIN,GXMAX,GXSTEP) 
C      CALL GQSCAL(3.0,4.0,GXMIN,GXMAX,GXSTEP)
       CALL GQSCAL(0.0,4.0,GXMIN,GXMAX,GXSTEP)
C
C     ----- Fig.1  WS-----
C
      DO NRAY=1,NRAYMX         
         DO IT=0,NITMAX(NRAY)
            DO N=1,6
            GKSY(IT+1,N)=GUCLIP(RAYB(25+N,IT))
            ENDDO
         ENDDO
      ENDDO
C
      CALL GMNMX1(GKSY(1,1),1,NITMAX(1),1,GYMIN1,GYMAX1)
C
      DO N=2,6
       CALL GMNMX1(GKSY(1,N),1,NITMAX(1),1,GYMIN,GYMAX)
       GYMIN1=MIN(GYMIN1,GYMIN)
       GYMAX1=MAX(GYMAX1,GYMAX)
      ENDDO
C
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
      CALL GQSCAL (GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL MOVE(1.7,16.1)
      CALL TEXT('X-WS',6)
C      CALL GDEFIN(1.7,11.7,9.0,16.0,0.0,GXMAX,-40.0,40.0)
      CALL GDEFIN(1.7,11.7,9.0,16.0,0.0,GXMAX,GYMIN,GYMAX)
      CALL GFRAME
C      CALL GSCALE(0.0,GXSTEP,0.0,5.0,0.1,9)
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,GYMIN,GYSTEP,1)
      CALL SETRGB(0.0,0.0,1.0)
C
      DO N=1,6
      CALL GPLOTP(GKX,GKSY(1,N),1,NITMAX(1)+1,1,0,0,0)
      CALL SETLIN(0,0,N)
      ENDDO
      CALL SETRGB(1.0,0.0,0.0)
      CALL SETRGB(0.0,0.0,0.0)
C
C    
C     
C     
C      
C
C
C     ------Fig2  WP-------
C   
C    
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            DO N=1,6
            GKPY( IT+1,N)=GUCLIP(RAYB(31+N,IT))
            ENDDO
         ENDDO
      ENDDO
C
      CALL GMNMX1(GKPY(1,1),1,NITMAX(1),1,GYMIN1,GYMAX1)
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C
      DO N=2,6
       CALL GMNMX1(GKPY(1,N),1,NITMAX(1),1,GYMIN,GYMAX)
       GYMIN1=MIN(GYMIN1,GYMIN)
       GYMAX1=MAX(GYMAX1,GYMAX)
      ENDDO
C
      CALL MOVE(1.7,8.1)
      CALL TEXT('X-WP',6)
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,GYMIN,GYMAX)
C       CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,-50.0,50.0)
C      CALL SETLIN(0,0,7)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,GYMIN,GYSTEP,1)
C      CALL GVALUE(0.0,0.0,0.0,0.01,2)
      CALL SETRGB(0.0,0.0,1.0)
C      
      DO N=1,6
      CALL GPLOTP(GKX,GKPY(1,N),1,NITMAX(1)+1,1,0,0,0)
      CALL SETLIN(0,0,N)
      ENDDO
C
      CALL SETRGB(1.0,0.0,0.0)
      CALL SETRGB(0.0,0.0,0.0)
C
C     ----- Fig.3   Angle-----
C
      DO NRAY=1,NRAYMX         
         DO IT=0,NITMAX(NRAY)
            GTHY( IT+1,1)=GUCLIP(RAYB(25,IT))
         ENDDO
      ENDDO
C
C      CALL GMNMX1(GTHY(1,1),1,NITMAX(1),1,GYMIN1,GYMAX1)
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C      CALL GQSCAL (GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL MOVE(13.5,16.1)
      CALL TEXT('Angle',6)
      CALL GDEFIN(13.5,23.5,9.0,16.0,0.0,GXMAX,-40.0,40.0)
C      CALL GDEFIN(13.5,23.5,9.0,16.0,0.0,GXMAX,GYMIN1,GYMAX1)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,0.0,5.0,0.1,9)
C      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
C      CALL GVALUE(0.0,2*GXSTEP,GYMIN,GYSTEP,1)
       CALL GVALUE(0.0,2*GXSTEP,0.0,10.0,1)
      CALL SETRGB(0.0,0.0,1.0)
C
      CALL GPLOTP(GKX,GTHY(1,1),1,NITMAX(1)+1,1,0,0,0)
      CALL SETRGB(1.0,0.0,0.0)
      CALL SETRGB(0.0,0.0,0.0)
C
C    
C     
C     
C      
C
C
C
C     -------fig4  LAMDA------------------------
C
            DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
C            GKY( IT+1,1)=GUCLIP(RAYB(47,IT))
C            GKY( IT+1,2)=GUCLIP(RAYB(48,IT))
            GKY( IT+1,1)=GUCLIP(RAYB(20,IT))
         ENDDO
      ENDDO
C
      CALL GMNMX1(GKY(1,1),1,NITMAX(1),1,GYMIN1,GYMAX1)
C      CALL GMNMX1(GKY(1,1),1,NITMAX(1),1,GYMINA,GYMAXA)
C      CALL GMNMX1(GKY(1,2),1,NITMAX(1),1,GYMINB,GYMAXB)
C
C      GYMIN1=MIN(GYMINA,GYMINB)
C      GYMAX1=MAX(GYMAXA,GYMAXB)
      CALL MOVE(13.5,8.1)
C      CALL TEXT('LAMDA',6)
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
C      CALL GDEFIN(13.5,23.5,1.0,8.0,0.0,GXMAX,GYMIN,GYMAX)
C      CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,-50.0,50.0)
      CALL GDEFIN(13.5,23.5,1.0,8.0,GXMIN,GXMAX,GYMIN,GYMAX)
C      CALL SETLIN(0,0,7)
      CALL GFRAME
      CALL GSCALE(GXMIN,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(GXMIN,2*GXSTEP,GYMIN,GYSTEP,1)
C      CALL GVALUE(0.0,0.0,0.0,0.01,2)
      CALL SETRGB(0.0,0.0,1.0)
C      
      CALL GPLOTP(GKX,GKY(1,1),1,NITMAX(1)+1,1,0,0,0)
      CALL GPLOTP(GKX,GKY(1,2),1,NITMAX(1)+1,1,0,0,0)
      CALL SETLIN(0,0,7)
C
      CALL SETRGB(1.0,0.0,0.0)
      CALL SETRGB(0.0,0.0,0.0)
      CALL WRGPRM
      CALL PAGEE
      RETURN
      END

C     ***** K,(K*B),K*(K*B),VG *****
C
      SUBROUTINE WRGRFG
C
      USE plcomm
      INCLUDE 'wrcomm.inc'
C
      DIMENSION GKX(NITM+1,1)
      DIMENSION GKY(NITM+1,3),GKBY(NITM+1,3),GKKBY(NITM+1,3)
      DIMENSION GVGY(NITM+1,3)
C
      CALL PAGES
      CALL SETFNT(32)
      CALL SETCHS(0.25,0.)
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C
C     ----- X AXIS -----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GKX( IT+1,NRAY)=GUCLIP(RAYB(0,IT))
         ENDDO
      ENDDO
C
      CALL GMNMX1(GKX,1,NITMAX(1),1,GXMIN1,GXMAX1)
      CALL GQSCAL(GKMIN1,GXMAX1,GXMIN,GXMAX,GXSTEP) 
C
C     ------fig 1  K----------
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GKY( IT+1,1)=GUCLIP(RAYB(38,IT))
            GKY( IT+1,2)=GUCLIP(RAYB(39,IT))
            GKY( IT+1,3)=GUCLIP(RAYB(40,IT))
         ENDDO
      ENDDO
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C
C      CALL GMNMX1(GKY(1,1),1,NITMAX(1),1,GYMINA,GYMAXA)
C      CALL GMNMX1(GKY(1,2),1,NITMAX(1),1,GYMINB,GYMAXB)
C      CALL GMNMX1(GKY(1,3),1,NITMAX(1),1,GYMINC,GYMAXC)
C
C      GYMIN1=MIN(GYMINA,GYMINB,GYMINC)
C      GYMAX1=MAX(GYMAXA,GYMAXB,GYMAXC)
      CALL MOVE(1.7,16.1)
      CALL TEXT('K',6)
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL GDEFIN(1.7,11.7,9.0,16.0,0.0,GXMAX,-1.2,1.2)
C       CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,-50.0,50.0)
C      CALL SETLIN(0,0,7)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,GYMIN,GYSTEP,1)
C      CALL GVALUE(0.0,0.0,0.0,0.01,2)
      CALL SETRGB(0.0,0.0,1.0)
C
      DO N=1,3
        CALL GPLOTP(GKX,GKY(1,N),1,NITMAX(1)+1,1,0,0,0)      
        CALL SETLIN(0,0,N+2)
      ENDDO  
C
      CALL SETRGB(1.0,0.0,0.0)
      CALL SETRGB(0.0,0.0,0.0)
C
C     ------fig 2 K*B---------
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GKBY( IT+1,1)=GUCLIP(RAYB(41,IT))
            GKBY( IT+1,2)=GUCLIP(RAYB(42,IT))
            GKBY( IT+1,3)=GUCLIP(RAYB(43,IT))
         ENDDO
      ENDDO
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C
C      CALL GMNMX1(GKBY(1,1),1,NITMAX(1),1,GYMINA,GYMAXA)
C      CALL GMNMX1(GKBY(1,2),1,NITMAX(1),1,GYMINB,GYMAXB)
C      CALL GMNMX1(GKBY(1,3),1,NITMAX(1),1,GYMINC,GYMAXC)
C
C      GYMIN1=MIN(GYMINA,GYMINB,GYMINC)
C      GYMAX1=MAX(GYMAXA,GYMAXB,GYMAXC)
      CALL MOVE(1.7,8.1)
      CALL TEXT('K*B',6)
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,-1.2,1.2)
C       CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,-50.0,50.0)
C      CALL SETLIN(0,0,7)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,GYMIN,GYSTEP,1)
C      CALL GVALUE(0.0,0.0,0.0,0.01,2)
      CALL SETRGB(0.0,0.0,1.0)
C
      DO N=1,3
        CALL GPLOTP(GKX,GKBY(1,N),1,NITMAX(1)+1,1,0,0,0)      
        CALL SETLIN(0,0,N+2)
      ENDDO  
C
      CALL SETRGB(1.0,0.0,0.0)
      CALL SETRGB(0.0,0.0,0.0)
C
C     ------fig 3 K*(K*B)-----
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GKKBY( IT+1,1)=GUCLIP(RAYB(44,IT))
            GKKBY( IT+1,2)=GUCLIP(RAYB(45,IT))
            GKKBY( IT+1,3)=GUCLIP(RAYB(46,IT))
         ENDDO
      ENDDO
C
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C
C      CALL GMNMX1(GKKBY(1,1),1,NITMAX(1),1,GYMINA,GYMAXA)
C      CALL GMNMX1(GKKBY(1,2),1,NITMAX(1),1,GYMINB,GYMAXB)
C      CALL GMNMX1(GKKBY(1,3),1,NITMAX(1),1,GYMINC,GYMAXC)
C
C      GYMIN1=MIN(GYMINA,GYMINB,GYMINC)
C      GYMAX1=MAX(GYMAXA,GYMAXB,GYMAXC)
      CALL MOVE(13.5,16.1)
      CALL TEXT('K*(K*B)',6)
      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL GDEFIN(13.5,23.5,9.0,16.0,0.0,GXMAX,-1.2,1.2)
C       CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,-50.0,50.0)
C      CALL SETLIN(0,0,7)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,GYMIN,GYSTEP,1)
C      CALL GVALUE(0.0,0.0,0.0,0.01,2)
      CALL SETRGB(0.0,0.0,1.0)
C
      DO N=1,3
        CALL GPLOTP(GKX,GKKBY(1,N),1,NITMAX(1)+1,1,0,0,0)      
        CALL SETLIN(0,0,N+2)
      ENDDO  
C
      CALL SETRGB(1.0,0.0,0.0)
      CALL SETRGB(0.0,0.0,0.0)
C
C     ------fig 4 VG ---------
C
      DO NRAY=1,NRAYMX
         DO IT=0,NITMAX(NRAY)
            GVGY( IT+1,1)=GUCLIP(RAYB(49,IT))
            GVGY( IT+1,2)=GUCLIP(RAYB(50,IT))
            GVGY( IT+1,3)=GUCLIP(RAYB(51,IT))
         ENDDO
      ENDDO
C
      CALL SETRGB(0.0,0.0,0.0)
      CALL SETLNW(0.035)
C      CALL GMNMX1(GVGY(1,1),1,NITMAX(1),1,GYMINA,GYMAXA)
C      CALL GMNMX1(GVGY(1,2),1,NITMAX(1),1,GYMINB,GYMAXB)
C      CALL GMNMX1(GVGY(1,3),1,NITMAX(1),1,GYMINC,GYMAXC)
C
C      GYMIN1=MIN(GYMINA,GYMINB,GYMINC)
C      GYMAX1=MAX(GYMAXA,GYMAXB,GYMAXC)
      CALL MOVE(13.5,8.1)
      CALL TEXT('VG',6)
C      CALL GQSCAL(GYMIN1,GYMAX1,GYMIN,GYMAX,GYSTEP)
      CALL GDEFIN(13.5,23.5,1.0,8.0,0.0,GXMAX,-1.2,1.2)
C       CALL GDEFIN(1.7,11.7,1.0,8.0,0.0,GXMAX,-50.0,50.0)
C      CALL SETLIN(0,0,7)
      CALL GFRAME
      CALL GSCALE(0.0,GXSTEP,GYMIN,GYSTEP,0.1,9)
      CALL GVALUE(0.0,2*GXSTEP,GYMIN,GYSTEP,1)
C      CALL GVALUE(0.0,0.0,0.0,0.01,2)
      CALL SETRGB(0.0,0.0,1.0)
C
      DO N=1,3
        CALL GPLOTP(GKX,GVGY(1,N),1,NITMAX(1)+1,1,0,0,0)      
        CALL SETLIN(0,0,N+2)
      ENDDO  
C
      CALL SETRGB(1.0,0.0,0.0)
      CALL SETRGB(0.0,0.0,0.0)
      CALL WRGPRM
      CALL PAGEE 
      RETURN
      END

C     ***** DRAW PARAMETERS *****
C
      SUBROUTINE WRGPRM
C
      USE plcomm
      INCLUDE 'wrcomm.inc'
C
C     ----- DRAW PARAMETERS -----
C
      CALL SETLIN(0,0,7)
      CALL WRPRMT(1.0,18.0, 'BB   =',6, BB  ,'(F8.3)',8)
      CALL WRPRMT(1.0,17.6, 'RR   =',6, RR  ,'(F8.3)',8)
      CALL WRPRMT(1.0,17.2, 'RA   =',6, RA  ,'(F8.3)',8)
      CALL WRPRMT(1.0,16.8, 'RKAP =',6, RKAP,'(F8.3)',8)
      CALL WRPRMT(5.0,18.0, 'Q0   =',6, Q0  ,'(F8.3)',8)
      CALL WRPRMT(5.0,17.6, 'QA   =',6, QA  ,'(F8.3)',8)
      CALL WRPRMT(5.0,17.2, 'RF =',  4, RF  ,'(1PE10.3)',10)
      CALL WRPRMT(5.0,16.8, 'NPHII=',6,RNPHII,'(F8.4)',8)
      CALL WRPRMT(9.0,18.0, 'PA(1)  =',8,PA(1),'(F8.4)',8)
      CALL WRPRMT(9.0,17.6, 'PZ(1)  =',8,PZ(1),'(F8.4)',8)
      CALL WRPRMT(9.0,17.2, 'PN(1)  =',8,PN(1),'(F8.4)',8)
      CALL WRPRMT(9.0,16.8, 'PNS(1) =',8,PNS(1),'(F8.4)',8)
      CALL WRPRMT(13.0,18.0,'PTPR(1)=',8,PTPR(1),'(F8.4)',8)
      CALL WRPRMT(13.0,17.6,'PTPP(1)=',8,PTPP(1),'(F8.4)',8)
      CALL WRPRMT(13.0,17.2,'PTS(1) =',8,PTS(1),'(F8.4)',8)
      CALL WRPRMT(13.0,16.8,'MODELP1=',8,DBLE(MODELP(1)),'(F4.0)',4)
      CALL WRPRMT(17.0,18.0,'PA(2)  =',8,PA(2),'(F8.4)',8)
      CALL WRPRMT(17.0,17.6,'PZ(2)  =',8,PZ(2),'(F8.4)',8)
      CALL WRPRMT(17.0,17.2,'PN(2)  =',8,PN(2),'(F8.4)',8)
      CALL WRPRMT(17.0,16.8,'PNS(2)= ',8,PNS(2),'(F8.4)',8)
      CALL WRPRMT(21.0,18.0,'PTPR(2)=',8,PTPR(2),'(F8.4)',8)
      CALL WRPRMT(21.0,17.6,'PTPP(2)=',8,PTPP(2),'(F8.4)',8)
      CALL WRPRMT(21.0,17.2,'PTS(2) =',8,PTS(2),'(F8.4)',8)
      CALL WRPRMT(21.0,16.8,'MODELP2=',8,DBLE(MODELP(2)),'(F4.0)',4)
      CALL PAGEE
      RETURN
      END
C
C***********************************************************************
C
      SUBROUTINE WRPRMT(X,Y,KTEXT,ITEXT,D,KFORM,IFORM)
C
      CHARACTER*(*) KTEXT,KFORM
      REAL*8 D
C
      CALL MOVE(X,Y)
      CALL TEXT(KTEXT,ITEXT)
      CALL NUMBD(D,KFORM,IFORM)
      RETURN
      END            
